﻿using System.ComponentModel.DataAnnotations.Schema;

namespace Entities
{
    /// <summary>
    /// a class just to match with the model (this is the "utiliser" entity)
    /// properties :
    ///     IdLobby : identifier of the lobby this is for
    ///     IdPlayer : identifier of the player this is for
    ///     Lobby : the lobby this is for
    ///     Player : the player this is for
    /// </summary>
    [Table("Use")]
    public class LobbyEntityPlayerEntity
    {
        [ForeignKey(nameof(Lobby))]
        public int IdLobby { get; set; }

        [ForeignKey(nameof(Player))]
        public int IdPlayer { get; set; }

        public LobbyEntity Lobby { get; set; } = null!;
        public PlayerEntity Player { get; set; } = null!;

        public int MaxScore { get; set; }
    }
}
