﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Entities
{
    /// <summary>
    /// a class to storage the maximum score of a player for a chapter
    /// properties :
    ///     IdChapter : identifier of the chapter this is for
    ///     IdPlayer : identifier of the player this is for
    ///     Chapter : the chapter this is for
    ///     Player : the player this is for
    /// </summary>
    [Table("Play")]
    public class PlayerEntityChapterEntity
    {
        [ForeignKey(nameof(Chapter))]
        [DatabaseGenerated(DatabaseGeneratedOption.None)]
        public int IdChapter { get; set; }

        [ForeignKey(nameof(Player))]
        [DatabaseGenerated(DatabaseGeneratedOption.None)]
        public int IdPlayer { get; set; }

        public ChapterEntity Chapter { get; set; } = null!;
        public PlayerEntity Player { get; set; } = null!;


        public int MaxScore { get; set; }
    }
}
