﻿using DbConnectionLibrairie;
using DataManagers;
using ExtensionsClassLibrairie;
using ManagerInterfaces;
using Model;
using OrderCriterias;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DTOs;

namespace ServiceManagers
{
    public class PlayerServiceManager(IPlayerManager<Player> manager) : IPlayerManager<PlayerDto>
    {
        private IPlayerManager<Player> manager = manager;

        public async Task<PlayerDto> addPlayer(PlayerDto playerdto)
        {
            return await Task.FromResult<PlayerDto>((await manager.addPlayer(playerdto.ToModel())).ToDto());
        }

        public async Task<int?> getMaxScorePlayer(int id, int idChapter)
        {
            return await manager.getMaxScorePlayer(id, idChapter);
        }

        public async Task<int?> getMaxScorePlayer(int id)
        {
            return await manager.getMaxScorePlayer(id);
        }

        public int getNbPlayers()
        {
            return manager.getNbPlayers();
        }

        public async Task<PlayerDto?> getPlayer(int id)
        {
            return await Task.FromResult<PlayerDto?>((await manager.getPlayer(id))?.ToDto());
        }

        public async Task<PlayerDto?> getPlayer(string nickname)
        {
            return await Task.FromResult<PlayerDto?>((await manager.getPlayer(nickname))?.ToDto());
        }

        public async Task<(int nbPages, IEnumerable<PlayerDto>? players)> getPlayers(int nb, int count, PlayerOrderCriteria orderCriteria = PlayerOrderCriteria.ById)
        {
            List<PlayerDto>? tmp = new List<PlayerDto>();
            var res = await manager.getPlayers(nb, count, orderCriteria);
            if (res.players == null) tmp = null;
            else
            {
                foreach (var item in res.players)
                {
                    tmp.Add(item.ToDto());
                }
            }
            return await Task.FromResult<(int nbPages, IEnumerable<PlayerDto>? players)>((res.nbPages, tmp));
        }

        public async Task<IEnumerable<PlayerDto>?> getPlayersInALobby(int idLobby)
        {
            List<PlayerDto>? tmp = new List<PlayerDto>();
            var res = await manager.getPlayersInALobby(idLobby);
            if (res == null) tmp = null;
            else
            {
                foreach (var item in res)
                {
                    tmp.Add(item.ToDto());
                }
            }
            return await Task.FromResult<IEnumerable<PlayerDto>?>(tmp);
        }

        public async Task<PlayerDto?> removePlayer(PlayerDto playerdto)
        {
            return (await manager.removePlayer(playerdto.ToModel()))?.ToDto();
        }

        public async Task<PlayerDto?> removePlayer(int id)
        {
            return (await manager.removePlayer(id))?.ToDto();
        }

        public async Task<PlayerDto?> updatePlayer(int id, PlayerDto player)
        {
            return (await manager.updatePlayer(id, player.ToModel()))?.ToDto();
        }
    }
}
